code	segment para
	assume cs:code,ds:code
	org 100h
intrcpt	proc far
	jmp	init
test	db	0
got	db	0
got1	db	0
	even
temp	dw	0
x40off	dw	0
x40seg	dw	0
x2foff	dw	0
x2fseg	dw	0
x40int:	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	pushf
	mov	ax,cs
	mov	ds,ax
	mov	ah,'a'
	mov	al,got
	cmp	ah,al
	jne	x1
	mov	ah,':'
	mov	al,got1
	cmp	ah,al
	jne	x2
	mov	ax,40h
	mov	bx,90h
	mov	ds,ax
	mov	dl,ds:[bx]
	mov	dh,0f0h
	and	dl,dh
	cmp	dl,50h
	jne	x2
	mov	dl,61h
	mov	ds:[bx],dl
x2:	jmp	x40out
x1:	mov	ah,test
	mov	al,got
	cmp	ah,al
	jne	x40out		;Not the proper drive letter
	mov	ah,':'
	mov	al,got1
	cmp	ah,al
	jne	x40out		;No colon
	mov	dl,0dfh		;The single step mask
	mov	ax,40h		;Segment
	mov	ds,ax
	mov	bx,90h		;40:90 is the address
	mov	dh,ds:[bx]
	and	dh,dl		;Mask out the double step bit
	mov	ds:[bx],dh	;Store it back
x40out:	popf
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	jmp	dword ptr cs:[x40off]	;Do the REAL INT 40H
x2fint:	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	pushf
 	cmp	ah,17 	;Is it the proper 2F Function?
 	jne	x2fout		;No
	cmp	al,35
	jne	x2fout
	mov	bx,ds:[si]	;SECRET STUFF!
	mov	ax,cs
	mov	ds,ax
	cmp	bh,':'
	jne	x2fout
	cmp	bl,90
	ja	x2f1
	mov	ch,bh
	xor	bh,bh
	add	bx,32
	mov	bh,ch
x2f1:	mov	got,bl
	mov	got1,bh
x2fout:	popf
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	jmp	dword ptr cs:[x2foff]	;Continue the 2F chain
	dw	0
table	dw	0
init:	mov	ah,30h
	int	21h		;Check for proper DOS
	cmp	al,3
	jae	i1
	jmp	badv
i1:	cmp	ah,2
	jae	i2
badv:	mov	ah,9
	lea	dx,messv
	int	21h
	xor	ax,ax
	int	21h
i2:	mov	al,10h
	out	70h,al		;Check to see if drive A is 1.2 megger
	in	al,71h
	mov	ah,0f0h		;Mask
	and	al,ah
	cmp	al,20h
	je	i3		;Yes it is a 1.2 megabyte floppy drive
	lea	dx,messd
	mov	ah,9
	int	21h
	xor	ax,ax
	int	21h
i3:	mov	bx,80h		;PSP address
	mov	al,[bx]		;Byte count
	cmp	al,0
	jne	i5
i4:	mov	ah,9
	lea	dx,messn
	int	21h
	xor	ax,ax
	int	21h
i5:	inc	bx
	mov	al,[bx]
	cmp	al,32
	je	i5
	cmp	al,13
	je	i4
	cmp	al,90
	ja	i6
	xor	ah,ah
	add	ax,32
i6:	cmp	al,100
	jb	i7
	cmp	al,122
	ja	i7
	jmp	i8
i7:	mov	ah,9
	lea	dx,messp
	int	21h
	xor	ax,ax
	int	21h
i8:	mov	test,al
	cli			;Start the vector swapping
	mov	cx,cs
	xor	ax,ax
	mov	es,ax
	mov	bx,256		;INT40H
	mov	ax,es:[bx]
	mov	x40off,ax
	mov	ax,offset x40int
	mov	es:[bx],ax
	add	bx,2
	mov	ax,es:[bx]
	mov	x40seg,ax
	mov	es:[bx],cx
	mov	bx,188		;INT2F
	mov	ax,es:[bx]
	mov	x2foff,ax
	mov	ax,offset x2fint
	mov	es:[bx],ax
	add	bx,2
	mov	ax,es:[bx]
	mov	x2fseg,ax
	mov	es:[bx],cx
	sti			;Vectors are swapped
	mov	ah,9
	lea	dx,messg
	int	21h
	mov	dx,offset table	;All that has to be resident
	int	27h		;Stay resident
messv	db	'Wrong DOS Version ---- Must be 3.2 or above'
	db	13,10,'$'
messd	db	'Drive A is NOT a high capacity drive'
	db	13,10,'$'
messn	db	'Requires NEW drive letter that DRIVER.SYS '
	db	'generated',13,10,'$'
messp	db	'Invalid drive specifier'
	db	13,10,'$'
messg	db	'Alpha Computer Service INTERCEPT is now loaded'
	db	13,10,'$'
intrcpt	endp
code	ends
	end	intrcpt
