/*t MSDOSDPB -- Define MS-DOS DPB Structure (Ver 2.xx & 3.xx) */
				/* Lattice		08-Oct-84 10:10 */
typedef struct {

           char Dpb_drive;		/* logical drive: 0=def, 1=A */
           char Dpb_unit;		/* driver unit number */
  unsigned int  Dpb_sector_size;	/* bytes per sector */
           char Dpb_cluster_mask;	/* sectors per cluster, -1 */
           char Dpb_cluster_shift;	/* log2 of sectors per cluster */
  unsigned int  Dpb_first_fat;		/* FAT starting sector */
           char Dpb_fat_count;		/* number of FAT's */
  unsigned int  Dpb_root_entries;	/* number of directory entries */
  unsigned int  Dpb_first_sector;	/* 1st cluster sector number */
  unsigned int  Dpb_max_cluster;	/* number of clusters + 1 */
           char Dpb_fat_size;		/* sectors per FAT */
  unsigned int  Dpb_dir_sector;		/* directory starting sector */
  unsigned int  Dpb_driver_off;		/* pointer to driver */
  unsigned int  Dpb_driver_seg;
           char Dpb_media;		/* media byte */
           char Dpb_first_access;	/* -1 indicates DPB not yet used */
  unsigned int  Dpb_next_dpb_off;	/* pointer to next DPB */
  unsigned int  Dpb_next_dpb_seg;
  unsigned int  Dpb_current_dir;	/* cluster # of current directory */
           char Dpb_dir_text[64];	/* path name */

				} MSDOS_Dpb;

#define DPB_MAX_12BIT  4079		/* max 12-bit cluster number */

				/******/
