/*t STANDARD.H -- Standard Definitions for SMALL Model */
/*						03-Nov-84  16:00 */

#define LPROG 0		/* small program */
#define LDATA 0		/* small data    */

#define TRUE  1
#define FALSE 0

#ifndef NULL
#if LDATA
#define NULL 0L
#else
#define NULL 0
#endif
#endif

typedef char     byte;
typedef unsigned uint;
typedef int      bool;
typedef int      VOID;

typedef union {
    struct {uint ax, bx, cx, dx, si, di, bp, ds, es, ss, cs;} w;
    struct {byte al, ah, bl, bh, cl, ch, dl, dh;}             b; } RuptRegs;

extern int d_errno;		/* error number from MS-DOS functions */

#define D_ERROR   -1

#define DO_RDONLY  0		/* d_open access modes */
#define DO_WRONLY  1
#define DO_RDWR    2

#define DFA_RO     0x01		/* d_create file attributes */
#define DFA_HID    0x02
#define DFA_SYS    0x04
#define DFA_VOL    0x08
#define DFA_DIR    0x10
#define DFA_ARC    0x20

long d_seek();

#define DSEEK_BEG  0		/* d_seek origin codes */
#define DSEEK_CUR  1
#define DSEEK_END  2

				/******/
